#version 120
#extension GL_ARB_shader_texture_lod : enable 
#define MAX_COLOR_RANGE 48.0
/*
!! DO NOT REMOVE !!
BSL Shaders is derived from Chocapic13 v5 test 2

This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !!
*/

/*
Disable an effect by putting "//" before "#define" when there is no number after
You can tweak the numbers, the impact on the shaders is self-explained in the variable's name or in a comment
*/

//ADJUSTABLE VARIABLES//

//SHADOW
	#define Shadow											//Casts shadow from sun / moon.
	
	#define ShadowFilter									//Shadow filtering. Improves shadow quality. Enable one only.
	//#define ShadowHQFilter								//Better shadow filtering. Costs performance. Enable one only.
	
	#define ShadowFix										//Completely removes shadow in dark areas. Fixes underground lighting.
	//#define ShadowColor									//Shadows behind stained glass are colored.
	#define ShadowType 1									//Set shadow method for semi-transparent block. 0:normal block shadow 1:double shadow(dithered). 2:water shadow [0 1 2]
	
	const int shadowMapResolution = 2048;					//Shadowmap resolution. Higher value costs performance. [1024 2048 4096 8192]
	const float shadowDistance = 256.0;						//Draw distance of shadow. [128.0 256.0 384.0 512.0]
	
//LIGHTING
	#define Lighting_SunlightVal 1.5						//Change sunlight strength. [0.5 1 1.5 2 2.5 3.0 3.5 4.0]
	#define Lighting_MoonlightVal 1.5						//Change moonlight strength. [0.5 1 1.5 2 2.5 3.0 3.5 4.0]
	float Lighting_Darkness = 0.2;							//Shadow darkness levels. Lower values mean darker shadow, 0.2 is default
	float Lighting_Brightness = 0.8;						//Sky brightness levels. Lower values mean darker sky, 0.8 is default
	
	//#define DynaWeather									//Enable dynamic weather.
		#define DynaWeather_Strength 0.4					//Change dynamic weather's transition range. [0.1 0.2 0.3 0.4 0.5 0.6]
		#define DynaWeather_Speed 1.0						//Change dynamic weather's transition speed. [0.25 0.5 1.0 2.0 4.0 8.0 16.0]
	
	#define TorchColor_Original								//Yellow-orangeish torch color. Enable one only.
	//#define TorchColor_Bright								//White-orangeish torch color. Enable one only.
	//#define TorchColor_White								//White torch color. Enable one only.
	//#define TorchColor_End								//Purple torch color. Enable one only.
	//#define TorchColor_Water								//Blue torch color. Enable one only.
	//#define TorchColor_Leaf								//Green torch color. Enable one only.
	#define TorchStrength 8									//Torch light intensity. [0.5 1 2 4 8 16 32 64 128 256 512]
	
	#define SkylightBrightness 0.0							//Brightness in dark area. [0.0 0.1 0.2 0.3 0.4 0.5]
	#define Lighting_Attenuation 2.2

	#define EmissiveRecolor									//Recolors some emissive blocks with torch color. Disabling this while using some torch color may give weird results.
	#define DarkDesaturation								//Desaturates color at night or dark area.
	#define SkyDesaturation									//Desaturates sky at night.
	#define DynamicHandlight								//Creates lighting around player when holding light source. Turn off if you use Optifine's dynamic handlight.
	//#define TorchFade										//Automatically adjusts torch strength based on eye brightness.
	#define SSS												//Light passes through leaves, grass, and some other blocks.
	//#define Lighting_NoTexture							//Replaces texture with gray color.
	
	#define Lighting_TextureMult 1.0
	#define Lighting_FinalMult 1.0
	
//VISUAL
	#define Godrays											//Screen space light shafts around sun and moon.
		const float density = 0.8;			
		const int NUM_SAMPLES = 8;							//increase this for better quality at the cost of performance /10 is default
		const float grnoise = 1.0;							//amount of noise /1.0 is default
		
	//#define VL											//World space light shafts.
		#define VL_QualityIn 5.0							//VL Quality while indoor. [1.0 2.0 3.0 4.0 5.0]
		#define VL_QualityOut 1.0							//VL Quality while outdoor. [1.0 2.0 3.0 4.0 5.0]
		#define VL_Distance 8								//Set VL render distance. Higher value costs performance. [2 4 6 8 10 12 14 16]
	
	//#define SSAO											//High quality ambient occlusion.
		#define SSAO_Side 4.0								//Set number of sides for ambient occlusion. Larger value means smoother edges. [4.0 5.0 6.0 7.0 8.0]
		#define SSAO_Depth 4.0								//Set number of layers for ambient occlusion. Larger value means smoother darkness. [4.0 5.0 6.0 7.0 8.0]
		#define SSAO_Size 40								//Set ambient occlusion size. [20 40 60 80 100 120]
		#define SSAO_Strength 1.0							//Set darkness level of ambient occlusion. [0.5 1.0 1.5 2.0 2.5 3.0]
		#define SSAO_Radius 1.0								//Set depth calculation range. [0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0]
		#define SSAO_Noise 1.0								//Set how smooth the ambient occlusion looks like. [0.0 0.25 0.5 0.75 1.0]
		const float ssaorad = 1;
	
	#define EDO												//Low quality ambient occlusion.
		#define EDO_Size 30.0								//Set ambient occlusion size. [10.0 20.0 30.0 40.0 50.0 60.0]
		#define EDOPASS 3.0
		#define EDOSTR 0.75									//Set ambient occlusion strength [0.5 0.75 1.0 1.25 1.5 1.75 2.0]
	
	//#define CelLighting									//Flattens torch light and sky light. Doesn't affect vanila smooth lighting.
	
	#define Gloss											//Specular replacement.
	
	//#define InverseTonemap								//Partially neutralize tonemap effect. Doesn't affect LUT.
	
	//#define RoundSunMoon
	
	//#define WaterCaustic									//Creates water caustics. Also affected by light sources.
	//#define WaterRipple									//Creates ripple effect near the player. Doesn't affect other players.
	#define WaterFogDepth 4.0								//Set fog depth for water. [1.0 2.0 3.0 4.0 5.0 6.0 7.0 8.0]
	
	//#define Watercolor_Vanila								//Pure texture based water. Only enable one.
	//#define Watercolor_Clear								//Clear-ish water. Only enable one.
	//#define Watercolor_Tropical							//Weak green-ish water. Only enable one.
	//#define Watercolor_Legacy								//Strong blue water. Only enable one.
	//#define Watercolor_Classic							//Weak light blue water. Only enable one.
	#define Watercolor_Original								//Strong dark blue water. Only enable one.
	
	#define WorldDimension 0								//The world dimension you're in. -1 : Nether | 0 : Overworld | 1 : End [0 -1 1]
	//#define WorldTimeAnimation							//Animate with world time.
	#define AnimationSpeed 1.0								//Set shader's speed. [0.1 0.25 0.5 0.75 1.0 2.0 3.0 4.0]
	
	const float	sunPathRotation	= -40.0f;					//Determines sun/moon inclination. [-60.0f -40.0f -20.0f 0.0f 20.0f 40.0f 60.0f]

//ADJUSTABLE VARIABLES//

const float 	wetnessHalflife 		= 70.0f;
const float 	drynessHalflife 		= 70.0f;

const bool 		shadowHardwareFiltering = true;
	
const int 		noiseTextureResolution  = 1024;
#define SHADOW_MAP_BIAS 0.85

varying vec4 texcoord;

varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 ambient_color;

varying vec4 lightS;

varying float handItemLight;
varying float handItemMult;
varying float emissiveRecolor;

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

uniform sampler2D gcolor;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D gnormal;
#ifdef Shadow
uniform sampler2DShadow shadow;
#ifdef ShadowColor
uniform sampler2DShadow shadowcolor;
uniform sampler2DShadow shadowtex1;
#endif
#endif
uniform sampler2D gaux1;
uniform sampler2D noisetex;

uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferModelView;
#ifdef Shadow
uniform mat4 shadowProjection;
uniform mat4 shadowModelView;
#endif

uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 upPosition;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;

uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float aspectRatio;
uniform float frameTimeCounter;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;

vec3 convertScreenSpaceToWorldSpace(vec2 co, float depth) {
    vec4 fragposition = gbufferProjectionInverse * vec4(vec3(co, depth) * 2.0 - 1.0, 1.0);
    fragposition /= fragposition.w;
    return fragposition.xyz;
}

vec3 convertCameraSpaceToScreenSpace(vec3 cameraSpace) {
    vec4 clipSpace = gbufferProjection * vec4(cameraSpace, 1.0);
    vec3 NDCSpace = clipSpace.xyz / clipSpace.w;
    vec3 screenSpace = 0.5 * NDCSpace + 0.5;
    return screenSpace;
}

float ld(float depth) {
    return (2.0 * near) / (far + near - depth * (far - near));
}

vec3 nvec3(vec4 pos) {
    return pos.xyz/pos.w;
}

vec4 nvec4(vec3 pos) {
    return vec4(pos.xyz, 1.0);
}

float edepth(vec2 coord) {
	return texture2D(depthtex0,coord).z;
}
const float dimread = WorldDimension;
vec2 newtc = texcoord.xy;
vec3 sky_color = normalize(vec3(0.1, 0.35, 1.));
float eBS = eyeBrightnessSmooth.y/240.0;

float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;

vec3 aux = texture2D(gaux1, texcoord.st).rgb;
vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0f - 1.0f;

#ifdef WorldTimeAnimation
float frametime = worldTime/20.0*AnimationSpeed;
#else
float frametime = frameTimeCounter*AnimationSpeed;
#endif

#ifdef DynaWeather
float dynaweather = max(pow((sin(frametime*0.07*DynaWeather_Speed)*0.25+cos(frametime*0.03*DynaWeather_Speed+6)*0.25+0.5),1.5)*(DynaWeather_Strength+0.1)-0.1,0.0);
#else
float dynaweather = 0.0;
#endif
float weatherval = mix(rainStrength,1.0,dynaweather);

float handlight = handItemLight;

#ifdef TorchColor_Original
vec3 TorchColor = vec3(0.7,0.28,0.04);
#endif
#ifdef TorchColor_Bright
vec3 TorchColor = vec3(0.7,0.35,0.15);
#endif
#ifdef TorchColor_White
vec3 TorchColor = vec3(0.4);
#endif
#ifdef TorchColor_End
vec3 TorchColor = vec3(0.65,0.27,0.65);
#endif
#ifdef TorchColor_Water
vec3 TorchColor = vec3(0.1,0.35,1.0);
#endif
#ifdef TorchColor_Leaf
vec3 TorchColor = vec3(0.15,0.75,0.15);
#endif

#ifdef Watercolor_Vanila
vec3 watercolor = vec3(0.02,0.08,0.28);
const float wateropacity = 0.2;
#endif

#ifdef Watercolor_Clear
vec3 watercolor = vec3(0.02,0.08,0.14);
const float wateropacity = 0.2;
#endif

#ifdef Watercolor_Tropical
vec3 watercolor = vec3(0.1,0.52,0.6);
const float wateropacity = 0.4;
#endif

#ifdef Watercolor_Legacy
vec3 watercolor = vec3(0.0,0.3,0.7);
const float wateropacity = 0.7;
#endif

#ifdef Watercolor_Classic
vec3 watercolor = vec3(0.1,0.4,0.7);
const float wateropacity = 0.4;
#endif

#ifdef Watercolor_Original
vec3 watercolor = vec3(0.03,0.07,0.12);
const float wateropacity = 0.8;
#endif

float modlmap = max((max(aux.b,0.5)-0.5)*2,0.0);
#ifdef CelLighting
float torch_lightmap = pow(floor(pow(max(aux.b,0.0)*1.5,1.8)*8.0)/8.0,2.0)*TorchStrength/8.0;
#else
float torch_lightmap = pow(modlmap-pow(modlmap,36.0),16.0)*32.0+pow(aux.b,1.8);
#endif

//float torch_lightmap = (1.0-exp(-aux.b*light_jitter/TORCH_ATTEN))*TorchStrength;

#ifdef CelLighting
float sky_lightmap = pow(floor(aux.r*8)/8,Lighting_Attenuation);
#else
float sky_lightmap = pow(aux.r,Lighting_Attenuation);
#endif

float iswet = wetness*pow(sky_lightmap,5.0)*sqrt(0.5+max(dot(normal,upVec),0.0));

	
//position distribution for shadow sampling		
const vec2 shadow_offsets[60] = vec2[60]  (  vec2( 0.0000, 0.2500 ),
									vec2( -0.2165, 0.1250 ),
									vec2( -0.2165, -0.1250 ),
									vec2( -0.0000, -0.2500 ),
									vec2( 0.2165, -0.1250 ),
									vec2( 0.2165, 0.1250 ),
									vec2( 0.0000, 0.5000 ),
									vec2( -0.2500, 0.4330 ),
									vec2( -0.4330, 0.2500 ),
									vec2( -0.5000, 0.0000 ),
									vec2( -0.4330, -0.2500 ),
									vec2( -0.2500, -0.4330 ),
									vec2( -0.0000, -0.5000 ),
									vec2( 0.2500, -0.4330 ),
									vec2( 0.4330, -0.2500 ),
									vec2( 0.5000, -0.0000 ),
									vec2( 0.4330, 0.2500 ),
									vec2( 0.2500, 0.4330 ),
									vec2( 0.0000, 0.7500 ),
									vec2( -0.2565, 0.7048 ),
									vec2( -0.4821, 0.5745 ),
									vec2( -0.51295, 0.3750 ),
									vec2( -0.7386, 0.1302 ),
									vec2( -0.7386, -0.1302 ),
									vec2( -0.51295, -0.3750 ),
									vec2( -0.4821, -0.5745 ),
									vec2( -0.2565, -0.7048 ),
									vec2( -0.0000, -0.7500 ),
									vec2( 0.2565, -0.7048 ),
									vec2( 0.4821, -0.5745 ),
									vec2( 0.51295, -0.3750 ),
									vec2( 0.7386, -0.1302 ),
									vec2( 0.7386, 0.1302 ),
									vec2( 0.51295, 0.3750 ),
									vec2( 0.4821, 0.5745 ),
									vec2( 0.2565, 0.7048 ),
									vec2( 0.0000, 1.0000 ),
									vec2( -0.2588, 0.9659 ),
									vec2( -0.5000, 0.8660 ),
									vec2( -0.7071, 0.7071 ),
									vec2( -0.8660, 0.5000 ),
									vec2( -0.9659, 0.2588 ),
									vec2( -1.0000, 0.0000 ),
									vec2( -0.9659, -0.2588 ),
									vec2( -0.8660, -0.5000 ),
									vec2( -0.7071, -0.7071 ),
									vec2( -0.5000, -0.8660 ),
									vec2( -0.2588, -0.9659 ),
									vec2( -0.0000, -1.0000 ),
									vec2( 0.2588, -0.9659 ),
									vec2( 0.5000, -0.8660 ),
									vec2( 0.7071, -0.7071 ),
									vec2( 0.8660, -0.5000 ),
									vec2( 0.9659, -0.2588 ),
									vec2( 1.0000, -0.0000 ),
									vec2( 0.9659, 0.2588 ),
									vec2( 0.8660, 0.5000 ),
									vec2( 0.7071, 0.7071 ),
									vec2( 0.5000, 0.8660 ),
									vec2( 0.2588, 0.9659 ));					

float Blinn_Phong(vec3 ppos, vec3 lvector, vec3 normal,float fpow, float gloss, float visibility, float glossmult)  {
	vec3 lightDir = vec3(lvector);
	
	vec3 surfaceNormal = normal;
	float cosAngIncidence = dot(surfaceNormal, lightDir);
	cosAngIncidence = clamp(cosAngIncidence, 0.0, 1.0);
	
	vec3 viewDirection = normalize(-ppos);
	
	vec3 halfAngle = normalize(lightDir + viewDirection);
	float blinnTerm = dot(surfaceNormal, halfAngle);
	
	float normalDotEye = dot(normal, normalize(ppos));
	float fresnel = clamp(pow(1.0 + normalDotEye, 5.0),0.0,1.0);
	fresnel = fresnel*0.85 + 0.15 * (1.0-fresnel);
	float pi = 3.1415927;
	float n =  pow(2.0,gloss*glossmult);
	return (pow(blinnTerm, n )*((n+8.0)/(8*pi)))*visibility;
}

float getnoise(vec2 pos) {
	return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f)+pos*100.0)) * 4378.5453f));
}

vec3 inverseUncharted2Tonemap(vec3 x) {
	float A = 1.0;
	float B = 0.37;
	float C = 0.1;
	float D = 0.2;		
	float E = 0.02;
	float F = 0.3;
	vec3 y = x;
	y += E/F;
	vec3 y1 = (y-D*E)/(A*y+C*B);
	vec3 y2 = (y-D*F)/(A*y+B);
	y = y1*y2*min(pow(length(x)*16,0.5),1.0);
	return y;
	//return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
}

float getdist(float rng) {
	return 1-clamp(ld(texture2D(depthtex0,texcoord.xy).r)/rng*far,0,1);
}

float edo(float ao) {
	//edge detect
	float temp = 0;
	float total = 0;
	float d = edepth(newtc.xy);
	float dtresh = 1/(far-near)/200.0;
	vec4 dc = vec4(d,d,d,d);
	float e = 0;
	vec4 sa;
	vec4 sb;
	
	float dist = (getdist(32)+getdist(64)*2.0+getdist(96)*3.0)/6.0;
	float border = floor(EDO_Size/EDOPASS*viewWidth/1280);
	float noise = 1+getnoise(texcoord.xy)*3.0/EDOPASS*dist;
	float mod = border*dist*noise;
	
	for (int i = 0; i < EDOPASS; i++) {
	sa.x = edepth(newtc.xy + vec2(-pw,-ph)*mod*i);
	sa.y = edepth(newtc.xy + vec2(pw,-ph)*mod*i);
	sa.z = edepth(newtc.xy + vec2(-pw,0.0)*mod*i);
	sa.w = edepth(newtc.xy + vec2(0.0,ph)*mod*i);
	
	//opposite side samples
	sb.x = edepth(newtc.xy + vec2(pw,ph)*mod*i);
	sb.y = edepth(newtc.xy + vec2(-pw,ph)*mod*i);
	sb.z = edepth(newtc.xy + vec2(pw,0.0)*mod*i);
	sb.w = edepth(newtc.xy + vec2(0.0,-ph)*mod*i);
	
	vec4 dd = (2.0* dc - sa - sb) - dtresh;
	dd = vec4(step(dd.x,0.0),step(dd.y,0.0),step(dd.z,0.0),step(dd.w,0.0));
	
	e = clamp(dot(dd,vec4(0.25f)),0.0,1.0);
	//e = e*(dist)+1-dist;
	total += e;
	dtresh = 1/(far-near)/(200.0+100*i);
	}
	total /= EDOPASS;
	
	total = mix(total,1.0,1.0-dist)*0.9+0.1;
	return ao*pow(total,EDOSTR);
}

float fx(float x) {
return (2 *(-sin(x)*sin(x)*sin(x) + 3*sin(x) + 3*x)) / 3;

}
float fx2(float x) {
return (-cos(x) * sin(x) + 6*x) / 2;

}

float subSurfaceScattering(vec3 pos, float N) {

return pow(max(dot(lightVector,normalize(pos)),0.0),N)*(N+1)/6.28;

}

float waterH(vec3 posxz, vec3 offset, float spd, float sz, float docaustic) {
float final = 0.0;
vec3 pos = posxz + offset;
//Noise
float noise = 0;
noise+= texture2D(noisetex,(pos.xz+vec2(frametime)*0.5-pos.y)/1024.0* 1.1).r*1.0;
noise+= texture2D(noisetex,(pos.xz-vec2(frametime)*0.5-pos.y)/1024.0* 1.5).r*0.8;
noise-= texture2D(noisetex,(pos.xz+vec2(frametime)*0.5+pos.y)/1024.0* 2.5).r*0.6;
noise+= texture2D(noisetex,(pos.xz-vec2(frametime)*0.5-pos.y)/1024.0* 5.0).r*0.4;
noise-= texture2D(noisetex,(pos.xz+vec2(frametime)*0.5+pos.y)/1024.0* 8.0).r*0.2;

//Ripple
float ripple = 0;
pos = posxz + offset*4.0;
if (docaustic > 0.9){
#ifdef WaterRipple
vec3 camtrail = (cameraPosition.xyz-previousCameraPosition)*2;
float rpos = length((pos-cameraPosition.xyz)*vec3(1.0,2.5,1.0)-vec3(0.0,1.5,0.0));
float rpos0 = rpos;
float rmult = 0.0;
for(int i = 0; i < 24; i++){
	float temp = length((pos-cameraPosition.xyz+camtrail*i/8)*vec3(1.0-i*0.025,2.5,1.0-i*0.025)-vec3(0.0,1.5,0.0))+i/10;
	rpos0 = min(rpos0,temp);
	rmult = max(rmult,(2.0*(1-i*0.0625)-temp)*0.5);
	}

ripple = sin(rpos0*10-frametime*4*spd)*rmult;
ripple = clamp(ripple*min(length(rpos),1.0),-1.0,1.0)*(1.0-isEyeInWater)*0.05;
#endif
}

final = (noise/pow(max(length(posxz),1.0),0.4))*max(1 - abs(ripple)*0.2,0.0) + ripple;
return final;
}

float find_closest(vec2 pos)
{
	const int ditherPattern[64] = int[64](
		0, 32, 8, 40, 2, 34, 10, 42,
		48, 16, 56, 24, 50, 18, 58, 26,
		12, 44, 4, 36, 14, 46, 6, 38,
		60, 28, 52, 20, 62, 30, 54, 22,
		3, 35, 11, 43, 1, 33, 9, 41,
		51, 19, 59, 27, 49, 17, 57, 25,
		15, 47, 7, 39, 13, 45, 5, 37,
		63, 31, 55, 23, 61, 29, 53, 21);

    vec2 positon = floor(mod(vec2(texcoord.s * viewWidth,texcoord.t * viewHeight), 8.0f));

	int dither = ditherPattern[int(positon.x) + int(positon.y) * 8];

	return float(dither) / 64.0f;
}


float distx(float dist){
	return (far * (dist - near)) / (dist * (far - near));
}

float getDepth(float depth) {
    return 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));
}


vec4 getShadowSpace(float shadowdepth, vec2 texcoord){

 vec4 fragpos = nvec4(convertScreenSpaceToWorldSpace(texcoord.st,shadowdepth));

 vec4 wpos = vec4(0.0);
  wpos = gbufferModelViewInverse * fragpos;

	wpos = shadowModelView * wpos;
	wpos = shadowProjection * wpos;
	wpos /= wpos.w;

	float distb = sqrt(wpos.x * wpos.x + wpos.y * wpos.y);
	float distortFactor = (1.0f - SHADOW_MAP_BIAS) + distb * SHADOW_MAP_BIAS;
	wpos.xy *= 1.0f / distortFactor;
	wpos = wpos * 0.5f + 0.5f;

 return wpos;

}

float getVolumetricRays(float pixeldepth, float land) {

	vec3 rSD = vec3(0.0);
	rSD.x = 0.0;
	rSD.y = pow(2.0,5-mix(VL_QualityIn,VL_QualityOut,eBS));
	rSD.z = find_closest(texcoord.xy);
	
	rSD.z *= rSD.y;

	int maxDist = int(16*VL_Distance);
	float minDist = 0.01f;
		minDist += rSD.z;

	vec2 diffthresh = vec2(0.0005, -0.001);	// Fixes light leakage from walls
	vec4 worldposition = vec4(0.0);

	for (minDist; minDist < maxDist; ) {
		if (getDepth(pixeldepth) < minDist){
			break;
		}
		worldposition = getShadowSpace(distx(minDist),texcoord.st);
		rSD.x += shadow2D(shadow, vec3(worldposition.rg, worldposition.b + diffthresh.x )).z;
		minDist = minDist + rSD.y;
}
	float vldiv = mix(maxDist,128,land);
	rSD.x /= vldiv/rSD.y;
	
	return rSD.x;
}

//////////////////////////////VOID MAIN//////////////////////////////

void main() {

	vec2 newtc = texcoord.xy;
	//unpack material flags
	float land = float(aux.g > 0.04);								//>0.04
	float iswater = float(aux.g > 0.04 && aux.g < 0.07);			//0.05
	float reflectable = float(aux.g > 0.08 && aux.g < 0.12);		//0.1
	float reflectnogloss = float(aux.g > 0.12 && aux.g < 0.14);		//0.13
	float reflectopaque = float(aux.g > 0.14 && aux.g < 0.17);		//0.15
	float translucent = float(aux.g > 0.38 && aux.g < 0.42);		//0.4
	float ismetal = float(aux.g > 0.48 && aux.g < 0.52);			//0.5
	float emissive = float(aux.g > 0.58 && aux.g < 0.62);			//0.6
	float emissivecolored = float(aux.g > 0.61 && aux.g < 0.65);	//0.63
	float islava = float(aux.g > 0.67 && aux.g < 0.69);				//0.68
	float particle = float(aux.g > 0.68 && aux.g < 0.72);			//0.7
	float hand = float(aux.g > 0.78 && aux.g < 0.82);				//0.8
	//float entity = float(aux.g > 0.88 && aux.g < 0.92);			//0.9
	float shading = 0.0f;
	float shadefix = 1.0;
	float spec = 0.0;
	float pixeldepth = 0.0;
	float ao = 1.0;

	float gx = floor(texcoord.x*viewWidth)-floor(texcoord.x*viewWidth*0.5)*2.0;
	float gy = floor(texcoord.y*viewHeight)-floor(texcoord.y*viewHeight*0.5)*2.0;
	float grid = mix(gx,1-gx,gy);
	float gridrange = -0.1+ShadowType*0.6;
	if(iswater > 0.9 || hand > 0.9 || reflectopaque > 0.9 || grid > gridrange) pixeldepth = texture2D(depthtex0,texcoord.xy).x;
	else pixeldepth = texture2D(depthtex1,texcoord.xy).x;

	float time = float(worldTime);
	float transition_fading = 1.0-(clamp((time-12000.0)/500.0,0.0,1.0)-clamp((time-13500.0)/500.0,0.0,1.0) + clamp((time-22500.0)/500.0,0.0,1.0)-clamp((time-23500.0)/500.0,0.0,1.0));	//fading between sun/moon shadows
	float night = clamp((time-13000.0)/500.0,0.0,1.0)-clamp((time-22500.0)/500.0,0.0,1.0);
	
	float tB = pow(abs(sin(time/12000*22/7)),2.0);
	
	vec3 nsunlight = normalize(mix(pow(sunlight,vec3(2.2)),vec3(0.25,0.3,0.4),weatherval));
	sky_color = normalize(mix(sky_color,vec3(0.25,0.3,0.4),weatherval)); //normalize colors in order to don't change luminance
	
	const float fresnel_pow = 5.0;
	
	vec3 color = texture2D(gcolor, newtc.st).rgb + vec3(0.001);
	color = pow(color,vec3(2.2))*Lighting_TextureMult;
	
	#ifdef EmissiveRecolor
	if (hand > 0.9 && emissiveRecolor > 0.9){
		float ec = clamp(pow(length(color),1.4),0,1);
		color = clamp(ec*pow(TorchColor,vec3(2.0))+pow(ec,1.7)*0.4,vec3(0),vec3(1));
		}
	#endif
	if (hand > 0.9){
		color *= 1+handItemMult*4;
		handlight = handItemMult;
		}
		
	float NdotL = dot(lightVector,normal);
	float NdotUp = dot(normal,upVec);
	
	vec4 fragposition = gbufferProjectionInverse * vec4(newtc.s * 2.0f - 1.0f, newtc.t * 2.0f - 1.0f, 2.0f * pixeldepth - 1.0f, 1.0f);
	fragposition /= fragposition.w;
	float mulfov = 1.0;
	if (isEyeInWater > 0.9){
		float fov = atan(1./gbufferProjection[1][1]);
		float fovUnderWater = fov*0.85;
		mulfov = gbufferProjection[1][1]*tan(fovUnderWater);
		}
		
	if (isEyeInWater > 0.9) fragposition.xy *= mulfov;

	vec4 worldposition = vec4(0.0);
	vec4 worldpositionraw = vec4(0.0);
	worldposition = gbufferModelViewInverse * fragposition;	
	float xzDistanceSquared = worldposition.x * worldposition.x + worldposition.z * worldposition.z;
	float yDistanceSquared  = worldposition.y * worldposition.y;
	worldpositionraw = worldposition;
	
	float uDepth = 0.0;
	if (iswater > 0.9 || isEyeInWater == 1.0 || (reflectable > 0.9 && grid < gridrange)) uDepth = texture2D(depthtex1,newtc.xy).x;
	vec4 uwPos = gbufferProjectionInverse * vec4((newtc.s * 2.0f - 1.0f)*mulfov, (newtc.t * 2.0f - 1.0f)*mulfov, 2.0f * uDepth - 1.0f, 1.0f);
	uwPos /= uwPos.w;
	uwPos = gbufferModelViewInverse * uwPos;
	vec4 uwPosraw = uwPos + vec4(cameraPosition.xyz,0.0);
		
	
	vec3 uPos = vec3(0);
	vec2 refract = vec2(0);
	float h0 = 0.0;
	float h1 = 0.0;
	float h2 = 0.0;
	float h3 = 0.0;
	float h4 = 0.0;
	float xDelta = 0.0;
	float yDelta = 0.0;
	float deltaPos = 0.1;
	vec3 posxz = worldposition.xyz+cameraPosition;
	if (iswater > 0.9) {
	h0 = waterH(posxz,vec3(0.0,0.0,0.0),1,0.4,1);
	h1 = waterH(posxz,vec3(deltaPos,0.0,0.0),1,0.4,1);
	h2 = waterH(posxz,vec3(-deltaPos,0.0,0.0),1,0.4,1);
	h3 = waterH(posxz,vec3(0.0,0.0,deltaPos),1,0.4,1);
	h4 = waterH(posxz,vec3(0.0,0.0,-deltaPos),1,0.4,1);
	
	xDelta = ((h1-h0)+(h0-h2))/deltaPos;
	yDelta = ((h3-h0)+(h0-h4))/deltaPos;
	
	refract = vec2(xDelta,yDelta)*0.01;
	
	uPos  = nvec3(gbufferProjectionInverse * nvec4(vec3(newtc.xy,uDepth) * 2.0 - 1.0));	
	}
	
	
	if (land > 0.9) {
		#ifdef Lighting_NoTexture
		color = mix(vec3(0.35 + 0.15*NdotUp)*(1-reflectable*0.2),watercolor,iswater*pow(wateropacity,1.0/2.2));
		#endif
		
		#ifdef Shadow
		float dist = length(fragposition.xyz);
		float distof = clamp(1.0-dist/shadowDistance,0.0,1.0);
		float distof2 = clamp(1.0-pow(dist/(shadowDistance*0.75),2.0),0.0,1.0);
		float shadow_fade = 1.0 - clamp((dist-(shadowDistance-16))/8,0.0,1.0);

		
		/*--reprojecting into shadow space --*/
		worldposition = shadowModelView * worldposition;
		float comparedepth = abs(worldposition.z);
		worldposition = shadowProjection * worldposition;
		worldposition /= worldposition.w;
		float distb = sqrt(worldposition.x * worldposition.x + worldposition.y * worldposition.y);
		float distortFactor = (1.0f - SHADOW_MAP_BIAS) + distb * SHADOW_MAP_BIAS;
		worldposition.xy *= 1.0f / distortFactor;
		worldposition = worldposition * 0.5f + 0.5f;
		
		uwPos = shadowModelView * uwPos;
		float comparedepth2 = abs(uwPos.z);
		uwPos = shadowProjection * uwPos;
		uwPos /= uwPos.w;
		float distb2 = sqrt(uwPos.x * uwPos.x + uwPos.y * uwPos.y);
		float distortFactor2 = (1.0f - SHADOW_MAP_BIAS) + distb2 * SHADOW_MAP_BIAS;
		uwPos.xy *= 1.0f / distortFactor2;
		uwPos = uwPos * 0.5f + 0.5f;
		
		vec4 shadowposition = worldposition;
		if (iswater > 0.9 || (reflectable > 0.9 && grid < gridrange)){
			comparedepth = comparedepth2;
			worldposition = uwPos;
			distortFactor = distortFactor2;
		}
		
		float altsfix = isEyeInWater;
		#ifdef SSS
		altsfix = max(translucent+reflectable*(1-float(gridrange < grid)),altsfix);
		#endif
			  shadefix = clamp(NdotL*2*(1-altsfix) + altsfix,0,1);
		float shadowstep = pow(2.0,0.5)/shadowMapResolution*(1.0+weatherval*3.0+altsfix);
		float diffscale = pow(2048.0/shadowMapResolution,2.2)*pow(shadowDistance/256,2.2);
		float diffthresh = (pow(distortFactor,2.0)*pow(diffscale,0.5)/144.0*(tan(acos(abs(NdotL))))+0.001/(pow(diffscale,0.5)*144.0));
		if (translucent > 0.9) diffthresh = 0.001;
		if (reflectable+iswater > 0.9) diffthresh = pow(distortFactor,2.0)*pow(2.0,0.5)*pow(diffscale,0.45)/128.0;
		diffthresh *= 1.0+weatherval+isEyeInWater*0.5;
		
		if (dimread == 0){
		if (comparedepth > 0.01 &&	worldposition.s < 0.99 && worldposition.s > 0.01 && worldposition.t < 0.99 && worldposition.t > 0.01 ) {
			if (NdotL < 0.0 && altsfix < 0.1){
					shading = 0.0;
				}
			
			else {
			#ifdef ShadowHQFilter
			float totalweight = 0.0;
			
			for(int i = 0; i < 60; i++){
					float dist = length(shadow_offsets[i]);
					float weight = pow(max(1-dist*0.99,0.01),0.5);
					shading += shadow2D(shadow,vec3(worldposition.st + shadow_offsets[i]*shadowstep, worldposition.z-diffthresh*(1+dist)*(1+weatherval))).x*weight;
					totalweight += weight;
				}
			shading /= totalweight;
			#else
			#ifdef ShadowFilter
			float dtmult = 2.0*(1+weatherval);
			shading  = shadow2D(shadow,vec3(worldposition.st, worldposition.z-diffthresh)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(shadowstep,0), worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(-shadowstep,0), worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(0,shadowstep), worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(0,-shadowstep), worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(shadowstep,shadowstep)*0.7, worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(-shadowstep,shadowstep)*0.7, worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(shadowstep,-shadowstep)*0.7, worldposition.z-diffthresh*dtmult)).x;
			shading += shadow2D(shadow,vec3(worldposition.st + vec2(-shadowstep,-shadowstep)*0.7, worldposition.z-diffthresh*dtmult)).x;
			shading = shading/9.0;
			#else
			shading  = shadow2D(shadow,vec3(worldposition.st, worldposition.z-diffthresh)).x;
			#endif
			#endif
			
			shading = shading*transition_fading;
			}
			
			#ifdef ShadowFix
			float shadowfixarea = clamp(pow(1-sky_lightmap*4,2.2)*4,0.0,1.0);
			if (isEyeInWater < 0.9) shading *= clamp(eBS*2.0-1.0,0.0,1.0)*shadowfixarea + (1-shadowfixarea);
			#endif
		}
		
		else shading = 1.0;
		}
		
		float wldfade = 1.0;
		if (dimread == -1 || dimread == 1) wldfade = 0.0;
		shading = shading * shadow_fade + (1-shadow_fade)*sky_lightmap*wldfade;
		#else
			#ifdef CelLighting
			shading = clamp(floor(pow(sky_lightmap,10.0)*256)/32,0,1);
			#else
			shading = clamp(pow(sky_lightmap,10.0)*2.0,0,1);
			#endif
			shading *= transition_fading*(NdotUp*0.5+0.5);
		#endif
		
		if (particle > 0.9) shading = sky_lightmap;
		if (emissivecolored > 0.9) shading *= 0.5;
		
		float sunshading = 0;
		#ifdef Shadow
		if (iswater > 0.9){
			sunshading = shadow2D(shadow,vec3(shadowposition.st, shadowposition.z-diffthresh)).x;
			}
		
		#endif
			
		#ifdef SSAO
		if (land > 0.9 && iswater < 0.9 && hand < 0.9 && particle < 0.9) {
			float pi = 22.0/7.0;
			vec3 norm = texture2D(gnormal,texcoord.xy).rgb*2.0-1.0;
			float aopixeldepth = texture2D(depthtex0,texcoord.xy).x;
			vec3 projpos = convertScreenSpaceToWorldSpace(texcoord.xy,aopixeldepth); 
			vec2 noiseAO = vec2(getnoise(texcoord.xy),getnoise(vec2(texcoord.x,-texcoord.y)))*2.0-1.0;
			
			float rprogress = 90.0;
			float sprogress = 1.0;
			ao = 0.0;
			float distval = 0.025*SSAO_Radius;
		
			float aosize = SSAO_Size/1280.0;
			float projrad = clamp(distance(convertCameraSpaceToScreenSpace(projpos + vec3(ssaorad,ssaorad,ssaorad)).xy,texcoord.xy),aosize*0.5,aosize);
			noiseAO = noiseAO*projrad/pow(SSAO_Side*SSAO_Depth,0.5)*viewWidth/1280*SSAO_Noise;
			
				for (int i = 0; i < SSAO_Depth; i++) {
					for (int j = 0; j < SSAO_Side; j++) {
						vec2 samplecoord = vec2(cos(rprogress*pi/180),sin(rprogress*pi/180))*(sprogress*projrad*vec2(1,aspectRatio)) + texcoord.xy + noiseAO;
						float sample = texture2D(depthtex1,samplecoord).x;
						vec3 sprojpos = convertScreenSpaceToWorldSpace(samplecoord,sample);
						float angle = pow(min(1.0-dot(norm,normalize(sprojpos-projpos)),1.0),1.5);
						float dist = pow(min(abs(ld(sample)-ld(aopixeldepth)),distval)/distval,1.5);
						float temp = min(dist+angle,1.0);
						ao += pow(temp,4.0);
						rprogress += 360/SSAO_Side;
					}
					sprogress = (1.0+i)/SSAO_Depth;
					rprogress += 180/SSAO_Side;
				}

				ao /= SSAO_Side*SSAO_Depth;
				ao = pow(ao,SSAO_Strength);
			}
		if (hand > 0.9) ao = edo(ao);
		#endif
		
		#ifdef EDO
			if (iswater < 0.9 && islava < 0.9) ao = edo(ao);
		#endif

		float diffuse = max(dot(lightVector,normal),0.0);
		
		diffuse = mix(diffuse,1.0,translucent*0.3);
		float sss = 0.0;
		#ifdef Shadow
			#ifdef SSS
			sss = subSurfaceScattering(fragposition.xyz,30.0)*Lighting_SunlightVal*2.0;
			sss = (mix(0.0,sss,max(shadow_fade-0.5,0.0)*2.0)*0.5+0.5)*translucent;
			#endif
		#endif
		
		float handLight = 0.0;
		#ifdef DynamicHandlight
		handLight = handlight*pow(max(1.0-length(fragposition.xyz/(pow(handlight*2.5,0.5)*20)),0.0),6.0)*(2.0+hand*3.0);
		#endif
		#ifdef CelLighting
		handLight = floor(handLight*10)/8;
		#endif
		
		shading *= 1-isEyeInWater*(1.0-eBS*0.5);
		float lmshading = shading*shadefix;
		lmshading = max(lmshading,sky_lightmap*0.5*pow(wateropacity,0.5)*iswater);
		vec3 colshading = vec3(lmshading);
		float cshadingmult = 1.0;

		#ifdef ShadowColor
		
		shadowstep = pow(2.0,0.5)/shadowMapResolution*(1.0+weatherval*3.0+altsfix);
		#ifdef ShadowHQFilter
		for(int i = 0; i < 60; i++){
			float dist = length(shadow_offsets[i]);
			colshading += shadow2D(shadowcolor,vec3(worldposition.st+shadow_offsets[i]*shadowstep, worldposition.z-diffthresh*(1+dist)*(1+weatherval))).rgb;
			}
		colshading /= 60;
		
		for(int i = 0; i < 60; i++){
			float dist = length(shadow_offsets[i]);
			cshadingmult += shadow2D(shadowtex1,vec3(worldposition.st+shadow_offsets[i]*shadowstep, worldposition.z-diffthresh*(1+dist)*(1+weatherval))).r;
			}
		cshadingmult /= 60;
		#else
		#ifdef ShadowFilter
		float dtmult = 2.0*(1+weatherval);
		colshading = shadow2D(shadowcolor,vec3(worldposition.st, worldposition.z-diffthresh)).rgb;
		colshading+= shadow2D(shadowcolor,vec3(worldposition.st + vec2(shadowstep,0), worldposition.z-diffthresh*dtmult)).rgb;
		colshading+= shadow2D(shadowcolor,vec3(worldposition.st + vec2(-shadowstep,0), worldposition.z-diffthresh*dtmult)).rgb;
		colshading+= shadow2D(shadowcolor,vec3(worldposition.st + vec2(0,shadowstep), worldposition.z-diffthresh*dtmult)).rgb;
		colshading+= shadow2D(shadowcolor,vec3(worldposition.st + vec2(0,-shadowstep), worldposition.z-diffthresh*dtmult)).rgb;
		colshading /= 5.0;
		
		cshadingmult = shadow2D(shadowtex1,vec3(worldposition.st, worldposition.z-diffthresh)).r;
		cshadingmult+= shadow2D(shadowtex1,vec3(worldposition.st + vec2(shadowstep,0), worldposition.z-diffthresh*dtmult)).r;
		cshadingmult+= shadow2D(shadowtex1,vec3(worldposition.st + vec2(-shadowstep,0), worldposition.z-diffthresh*dtmult)).r;
		cshadingmult+= shadow2D(shadowtex1,vec3(worldposition.st + vec2(0,shadowstep), worldposition.z-diffthresh*dtmult)).r;
		cshadingmult+= shadow2D(shadowtex1,vec3(worldposition.st + vec2(0,-shadowstep), worldposition.z-diffthresh*dtmult)).r;
		cshadingmult = cshadingmult / 5.0;
		#else
		colshading = shadow2D(shadowcolor,vec3(worldposition.st, worldposition.z-diffthresh)).rgb;
		
		cshadingmult = shadow2D(shadowtex1,vec3(worldposition.st, worldposition.z-diffthresh)).r;
		#endif
		#endif
		cshadingmult *= mix(NdotL,1.0,reflectable-reflectopaque)*(1-reflectopaque)*(1-isEyeInWater*0.75);
		
		colshading = mix(colshading*(4.0-2.0*(reflectable-reflectopaque))*cshadingmult,vec3(1),lmshading);
		
		#endif
		
		vec3 light_col = mix(pow(sunlight,vec3(2.2))*Lighting_SunlightVal,moonlight*4*Lighting_MoonlightVal,moonVisibility);
		light_col *= (5.0-4.4*eBS)*(1-weatherval*0.8) * (1+lmshading)*0.5 * ((0.5+0.3*sunVisibility)+pow(tB,0.5)*(0.5-0.3*sunVisibility));
		light_col = mix(light_col,vec3(length(light_col))*0.3,weatherval*0.9);
		if (isEyeInWater > 0.9) light_col = pow(watercolor*wateropacity+(1-wateropacity),vec3(wateropacity))*pow(length(light_col),0.5)*eBS;
		vec3 Sunlight_lightmap = light_col*colshading*(1.0-weatherval*0.95)*mix(diffuse,1.0,isEyeInWater*0.5)*transition_fading;

		//underwater position
		vec3 uVec = fragposition.xyz-uPos;
		float UNdotUP = abs(dot(normalize(uVec),normal));
		float depth = length(uVec)*UNdotUP;
		float sky_absorbance = mix(mix(1.0,exp(-depth/WaterFogDepth),iswater),1.0,isEyeInWater);
		
		vec3 causticcol = vec3(0);
		#ifdef WaterCaustic
		float caustic = 0;
		float csmask = mix(iswater,1-iswater,isEyeInWater)*(1-particle);
		float cstorchlm = max(1-sky_lightmap*1.2*mix(1-night*0.5,0.5,weatherval),0.0)*(max(torch_lightmap-0.1,0.0)+pow(handLight*0.9,2.2)*4)*10;
		cstorchlm *= csmask;
		csmask *= max(lmshading,sky_lightmap*0.1)*(1-night*0.95)*(1-weatherval);
		vec3 cslc = (sunlight*sunVisibility+moonlight*(1+moonVisibility*128))*(1-isEyeInWater)+isEyeInWater*0.5;
		
		h0 = waterH(uwPosraw.xyz,vec3(0.0,0.0,0.0),1.0,1.0,0);
		h1 = waterH(uwPosraw.xyz,vec3(deltaPos,0.0,0.0),1.0,1.0,0);
		h2 = waterH(uwPosraw.xyz,vec3(-deltaPos,0.0,0.0),1.0,1.0,0);
		h3 = waterH(uwPosraw.xyz,vec3(0.0,0.0,deltaPos),1.0,1.0,0);
		h4 = waterH(uwPosraw.xyz,vec3(0.0,0.0,-deltaPos),1.0,1.0,0);
		caustic = max(2-(abs(h2-h1)+abs(h4-h3))*6.0-pow(abs(h0-0.5),3.0)*12.0,0.0);
		caustic = max(pow(caustic,6.0),0.0)*pow(wateropacity,0.4)*0.75;
		causticcol = caustic*((1+color)*cslc*csmask+TorchColor*cstorchlm);
		if (isEyeInWater > 0.9) causticcol *= pow(watercolor/wateropacity,vec3(0.25))*(1-wateropacity*0.25);
		#endif
		
		tB = pow(tB,0.5);
		float avglightstr = (Lighting_Brightness + Lighting_Darkness)*0.5;
		float skylightstr = Lighting_Brightness;
		float shdlightstr = Lighting_Darkness+(1-eBS)*0.3;
		skylightstr = mix(mix(avglightstr,skylightstr,sky_lightmap),avglightstr*2,weatherval);
		shdlightstr = mix(shdlightstr,avglightstr*2,weatherval);
		
		vec3 emissivecol = ((emissive+islava*4)+(2.0-length(color)*1.0)*emissivecolored)*color*6.0;
		emissivecol *= 2.0-NdotUp;
		if (particle > 0.9) color *= 2;
		
		vec3 skycolorsun = mix(pow(sky_color,vec3(0.75)),nsunlight,(1.0-pow(tB,0.5)*0.8)*lmshading)*4.0*sunVisibility*(2.0-lmshading*(1-weatherval)-weatherval)*(1.0-weatherval*0.9)*pow(float(Lighting_SunlightVal),0.5);
		vec3 skycolormoon = pow(moonlight,vec3(0.9))*moonVisibility*16.0*pow(float(Lighting_MoonlightVal),0.75);
		vec3 skycolor = (skycolorsun+skycolormoon);
		skycolor = mix(skycolor,vec3(length(skycolor))*vec3(0.625,0.75,1.0),pow(weatherval,2.2));

		vec3 sky_light = pow(skycolor*0.5,vec3(1.4));
			 if(isEyeInWater < 0.9){
			 sky_light*= mix(shdlightstr,skylightstr,mix(lmshading,1.0,night*0.7));
			 sky_light*= max(sky_lightmap,lmshading)*(0.1+(1.0-sunVisibility+tB*0.4)*0.9);
			 sky_light+= vec3(1.5-0.5*eBS)*pow(clamp(max(sky_lightmap,lmshading)*1.01-0.01,0.0,1.0),1.0)*(((1.0+4.0*tB)*(1-eBS))+0.5) *(1-weatherval)*(1-moonVisibility)*(0.25+lmshading*0.75);
			 sky_light+= sky_lightmap*weatherval*0.05*sunVisibility;
			 }
			 if (isEyeInWater > 0.9) sky_light = pow(sky_light,vec3(0.3))*0.2*(1-wateropacity*0.5)*(eBS*0.9+0.1);
		if (dimread == -1) sky_light += 0.025;
		if (dimread == 1) sky_light += 0.1;
		
		float torchfd = 1.0;
		#ifdef TorchFade
		torchfd = 1.0-0.8*eBS*sunVisibility*(1-rainStrength);
		#endif
		
		vec3 torchcolor = vec3(TorchColor);
		torchcolor = mix(pow(max(torchcolor-0.1,vec3(0.0)),vec3(2.0)),torchcolor,pow(torch_lightmap+handLight,0.25));
		vec3 color_torchlight = (torch_lightmap+handLight)*torchcolor*torchfd + vec3(0.01)*(2.0-1.5*eBS);
		
		#ifdef DarkDesaturation
		float sata1 = max(mix(sky_lightmap,1.0,eBS*sunVisibility)*1.1*(1-pow(weatherval,2.0)*0.2*(4.0-3.0*sunVisibility))*(sunVisibility*0.8+0.2),lmshading*sunVisibility*(1-weatherval));
		float sata2 = (torch_lightmap+handLight)*4.0;
		float sata = clamp(sata1*mix(3.0-moonVisibility,1.0,weatherval) + sata2,0.1,1.0);
		vec3 satb1 = vec3(0);
		vec3 satb2 = vec3(0);
		if (dimread == 0){
		satb1 = moonlight*24.0+vec3(0.5);
		satb1 = mix(satb1,vec3(0.2+0.3*sunVisibility),weatherval);
		satb2 = vec3(0.5);
		}
		if (dimread == -1){
		satb1 = vec3(1,0.3,0.1);
		satb2 = satb1;
		}
		if (dimread ==  1){
		sata = sata*0.8 + 0.2;
		satb1 = vec3(0.8,0.6,1);
		satb2 = satb1;
		}
		vec3 satc = vec3(satb1)*sky_lightmap+satb2*(1-sky_lightmap);
		vec3 satd = (color.r+color.g+color.b)/3*satc;
		color = color*sata + satd*(1-sata);
		#endif
		
		float blockspec = 0.0;
		float bspecmult = (1.0-night*0.9) * (1.0-isEyeInWater) * transition_fading;
		if (land > 0.9 && iswater < 0.9 && hand < 0.9){
			if (reflectable > 0.9 || ismetal > 0.9) blockspec = clamp(Blinn_Phong(fragposition.xyz,lightVector,normal,fresnel_pow,1,shading*diffuse,8 + night) * bspecmult * 0.1,0.0,1.0);
			else blockspec = clamp(Blinn_Phong(fragposition.xyz,lightVector,normal,fresnel_pow,1,shading*diffuse,4 + night) * bspecmult,0.0,1.0);
			}
		vec3 lightspec = vec3(0);
		
		#ifdef Gloss
		vec3 glosscol = mix(pow(sunlight,vec3(0.7))*0.5*Lighting_SunlightVal,moonlight*2.5*Lighting_MoonlightVal,moonVisibility)*1.5;
		lightspec = blockspec*glosscol*(1+night*7)*(1-weatherval)*(1+tB)/2;
		#endif
		
		vec3 ssscol = sss * light_col * shading *(1.0-weatherval*0.9)*transition_fading;
		vec3 slbrightness = vec3((1-sky_lightmap)*SkylightBrightness*0.2);
		float handmult = mix(1.0,max(NdotUp*0.2,0.0)+0.8,hand);
		
		#ifdef InverseTonemap
		vec3 whitescale = inverseUncharted2Tonemap(vec3(1.0));
		if (particle < 0.9 && hand < 0.9) color = inverseUncharted2Tonemap(color);
		color *= mix(whitescale,vec3(1.0),length(color));
		#else
		if (particle < 0.9 && hand < 0.9) color = mix(color,inverseUncharted2Tonemap(vec3(length(color)))*normalize(color),0.25);
		#endif
		
		vec3 light_a = Sunlight_lightmap + ssscol + emissivecol + lightspec + causticcol;
		vec3 light_b = sky_light + color_torchlight + slbrightness;
		color = color*(light_a+light_b)*sky_absorbance*handmult*Lighting_FinalMult;
		ao = mix(ao,1,min(pow(length(light_a)*0.62,3.0),1.0));
		
		if (iswater > 0.9 && isEyeInWater < 0.9) color = mix(watercolor*pow(length(ambient_color),0.2)*0.05,color,exp(-depth/WaterFogDepth));
		if (iswater > 0.9 && isEyeInWater > 0.9) color /= 4.0-eBS;
		
		float landinwater = texture2D(depthtex1,texcoord.xy).r-texture2D(depthtex0,texcoord.xy).r;
		
		if (isEyeInWater > 0.9 && landinwater < 0.00001) color = mix(color,length(color)*watercolor,max(wateropacity*(1-(torch_lightmap+handlight)),0.0));

		spec = Blinn_Phong(fragposition.xyz,lightVector,normal,fresnel_pow,1,pow(sunshading*diffuse,4),11 + night) * iswater * (1.0-isEyeInWater)*transition_fading;
		spec += blockspec;
	}
	
	else {
	color = color*4;
	
	#ifdef SkyDesaturation
	float sata = (1-night);
	vec3 satb = moonlight*43.2+vec3(0.1);
	vec3 satd = vec3(color.r+color.g+color.b)/3*satb;
	color = color*sata + satd*(1-sata);
	#endif
	
	if (dimread == -1 || dimread == 1) color = vec3(0);
	}

	float gr = 0.0;
	if (dimread == 0 && isEyeInWater == 0){
		#ifdef Godrays
			vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			tpos = vec4(tpos.xyz/tpos.w,1.0);
			vec2 pos1 = tpos.xy/tpos.z;
			vec2 lightPos = pos1*0.5+0.5;
			

				vec2 deltaTextCoord = vec2( newtc.st - lightPos.xy );
				vec2 textCoord = newtc.st;
				deltaTextCoord *= density/(float(NUM_SAMPLES));
				float sample = 0.0;
				float avgdecay = 0.0;
				float dither = find_closest(texcoord.xy);
				float falloff = 1.0;
				
				if (texcoord.x > 0.0 && texcoord.y > 0.0 && texcoord.x < 1.0 && texcoord.y < 1.0){
					for(int i=0; i < NUM_SAMPLES ; i++) {			
						textCoord -= deltaTextCoord;
						sample = step(texture2D(gaux1, textCoord + deltaTextCoord*dither).g,0.01);
						falloff *= 0.9;
						
						gr += sample*falloff;
					}
				}
		gr /= NUM_SAMPLES;
		#endif
	}

	#ifdef VL
	gr = getVolumetricRays(pixeldepth,land);
	gr *= mix(pow(gr,8.0),1.0,land);
	//color.rgb = color*0.02 + vec3(gr);
	#endif

	color = clamp(pow(color/MAX_COLOR_RANGE,vec3(1.0/2.2)),1.0/255.0,1.0);
	
/* DRAWBUFFERS:31 */
	gl_FragData[0] = vec4(color, spec);
	gl_FragData[1] = vec4(gr,refract.x*0.5+0.5,refract.y*0.5+0.5,ao);
}
